#include <iostream>
#include <string>
#include <assert.h>
using namespace std;
//     ASCII 
char nibble_to_hex(uint8_t i)
{
	char digits[] = "0123456789abcdef";	//   
	assert(0x0 <= i && i <= 0xf);	//      
	return digits[i];		// ,  
}
//      
void print_in_hex(uint8_t byte) {
	cout << nibble_to_hex(byte >> 4)
		<< nibble_to_hex(byte & 0xf);
}
//    
const uint8_t* as_bytes(const void* data)
{
	return reinterpret_cast<const uint8_t*>(data);
}
//     16 
void print_in_hex(const void* data, size_t size) {
	const uint8_t* bytes = as_bytes(data);	//   
	for (size_t i = 0; i < size; i++) {
		print_in_hex(bytes[i]);
		//   :   ,  16   .
		if ((i + 1) % 16 == 0) {	//  16     
			cout << '\n';
		}
		else {
			cout << ' ';
		}
	}
}
//     ASCII 
char bit_digit(uint8_t byte, uint8_t bit) {
	if (byte & (0x1 << bit)) {
		return '1';
	}
	return '0';
}
//      
void print_in_binary(uint8_t byte) {
	for (int bit = 7; bit >= 0; bit--) {// 
		cout << bit_digit(byte, bit);
	}
}
//      
void print_in_binary(const void* data, size_t size) {
	const uint8_t* bytes = as_bytes(data);
	for (size_t i = 0; i < size; i++) {
		print_in_binary(bytes[i]);
		//   :   ,  4   .
		if ((i + 1) % 4 == 0) {
			cout << '\n';
		}
		else {
			cout << ' ';
		}
	}
}

int main()
{
	string action;
	uint16_t operand1, operand2, result;
	setlocale(LC_ALL, "Russian");// 
	cout << " : ";
	//  
	cin >> operand1;
	cin >> action;
	cin >> operand2;
	if (action == "&")	//         
	{
		result = operand1 & operand2;
	}
	else if (action == "|")
	{
		result = operand1 | operand2;
	}
	else if (action == "^")
	{
		result = operand1 ^ operand2;
	}
	else
	{
		cout << " " << endl;
		system("pause");
		return 1;
	}
	//  16 
	print_in_hex(&operand1, sizeof(operand1));
	cout << action << " ";
	print_in_hex(&operand2, sizeof(operand2));
	cout << "= ";
	print_in_hex(&result, sizeof(result));
	cout << endl;
	// 
	print_in_binary(&operand1, sizeof(operand1));
	cout << action << endl;
	print_in_binary(&operand2, sizeof(operand2));
	cout << "=" << endl;
	print_in_binary(&result, sizeof(result));
	cout << endl;
	system("pause");
	return 0;
}
